<?php

namespace SenSai;

use ManiaControl\Commands\CommandListener;
use ManiaControl\ManiaControl;
use ManiaControl\Players\Player;
use ManiaControl\Plugins\Plugin;
use Maniaplanet\DedicatedServer\Xmlrpc\PlayerStateException;
use Maniaplanet\DedicatedServer\Xmlrpc\UnknownPlayerException;
use ManiaControl\Settings\Setting;
use ManiaControl\Settings\SettingManager;

/**
 * ManiaControl Chat-Message Extender Plugin
 *
 * @author    G]R [SG-1] Sen-Sai

 */
class ChatMessageEXTPlugin implements CommandListener, Plugin {
	/*
	 * Constants
	 */
	const PLUGIN_ID				= 61;
	const PLUGIN_VERSION		= 1.2;
	const PLUGIN_NAME			= 'ChatMessageEXTPlugin';
	const PLUGIN_AUTHOR			= 'G]R [SG-1]Sen-sai';
	
	const SETTING_CMD_TXT_0		= 'Command A';
	const SETTING_CMD_TXT_1		= 'Command B';
	const SETTING_CMD_TXT_2		= 'Command C';
	const SETTING_CMD_TXT_3		= 'Command D';
	const SETTING_CMD_TXT_4		= 'Command E';
	const SETTING_CMD_TXT_5		= 'Command F';
	const SETTING_CMD_TXT_6		= 'Command G';
	const SETTING_CMD_TXT_7		= 'Command H';
	const SETTING_CMD_TXT_8		= 'Command I';
	const SETTING_CMD_TXT_9		= 'Command J';
	/*
	 * Private properties
	 */
	/** @var ManiaControl $maniaControl */
	private $maniaControl = null;
	private $cmd = array();

	/**
	 * @see \ManiaControl\Plugins\Plugin::prepare()
	 */
	public static function prepare(ManiaControl $maniaControl) {

		
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getId()
	 */
	public static function getId() {
		return self::PLUGIN_ID;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getName()
	 */
	public static function getName() {
		return self::PLUGIN_NAME;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getVersion()
	 */
	public static function getVersion() {
		return self::PLUGIN_VERSION;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getAuthor()
	 */
	public static function getAuthor() {
		return self::PLUGIN_AUTHOR;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getDescription()
	 */
	public static function getDescription() {
		return "Extends ChatMessgePlugin with 10 custom commands";
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::load()
	 */
	public function load(ManiaControl $maniaControl) {
		$this->maniaControl = $maniaControl;
		/**
		 * Chat commands
		 * usage 	: <CHATCOMMAND>|<TXT>|<SPECIALCOMMAND>|<DESCRIPTION>
		 * 			: SPECIALCOMMAND: Either 'login' or 'msg' or 'both'
		 			: login 		: Allow to send the message with a loginname of a player (optional! So you can set to login, but if no login is given message will still be shown)
					: login 		: example : /gb <LOGIN> will print something like : <YOUR NAME> says: Grabbing a beer <NAME OF OTHER PLAYER>
					: msg 			: Have the message printed and add the extra text (chat command can be e.g. /gb cause I'm really thursty!)
					: both 			: Have the message printed and add the extra text (chat command can be e.g. /gb <LOGINNAME> cause I'm really thursty!)
					: DESCRIPTION 	: Shown when someone uses the help command on chatcommands
					: DO NOT USE ' OR " OR \ 
		*/
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_0, 'ml|More Luck Please|login|Writes more luck message to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_1, 'gd|Grabbing a drink|both|Writes grabbing a drink to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_2, 'cm|Nice tent you have there|both|Writes Camp more to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_3, 'sk|Spawn killer spotted:|login|Writes Spawn killer spotted to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_4, 'nb|I need a beer!|msg|Writes I need a beer to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_5, 'ss|I need something stronger to drink|both|Writes I need something stronger to drink to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_6, 'gr|I love the Glimratten server|both|Writes I love the Glimratten server to the chat');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_7, '');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_8, '');
		$this->maniaControl->getSettingManager()->initSetting(get_class(), self::SETTING_CMD_TXT_9, '');	
		$this->loadIntoArray();
		foreach($this->cmd as $ccmd)
			{
				$command = explode("|",$ccmd);
				
				
				if(count($command)==4)
				{
					$this->maniaControl->getCommandManager()->registerCommandListener($command[0], $this, 'handleChatCmd', false, $command[3]);
					
				}
			}	
		return true;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::unload()
	 */
	public function unload() {
	}

	/**
	 * Builds a chat message starting with the player's nickname, can used to express emotions
	 *
	 * @param array  $chat
	 * @param Player $player
	 */
	 
	public function handleChatCmd(array $chat, Player $player) {
		$chatcommand = explode(" ", $chat[1][2]);
		$count=count($this->cmd);
		
		for($i=0;$i<=$count;$i++){
			$command = explode("|",$this->cmd[$i]);
			if ($command[0]===(substr($chatcommand[0],1))) { break; }
			
			
			unset ($command);
		}
		if ($command[0]!==(substr($chatcommand[0],1))) { return; }
		
		if($command[2]=="msg") {
			$length=strlen($command[0])+2;
			$txt = substr($chat[1][2],$length);
			if(strlen($txt)>2)
			{
				$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' '.$txt;
			}
			else
			{
				$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1];
			}
		}
		if($command[2]=="login") {
			if (isset($chatcommand[1])) {
				if ($this->getTarget($chatcommand[1])) {
					$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' $z$<' . $this->getTarget($chatcommand[1]) . '$>$i!';
					} 
				else {
				$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1];
				}
			}
		}
		if($command[2]=="both") {
			if (isset($chatcommand[1])) { // do we have a second param?
				if ($this->getTarget($chatcommand[1])) { // is it an exisiting user ?
					$length_a=strlen($command[0])+2; // Command length + 2 for the / and the space
					$length_b=strlen($chatcommand[1])+1; // add 1 for the space
					$length=$length_a+$length_b; //start of the message
					$txt = substr($chat[1][2],$length);
					if(strlen($txt)>2) {
						$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' $z$<' . $this->getTarget($chatcommand[1]) . '$>$i! '.$txt;
					}
					else
					{
						$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' $z$<' . $this->getTarget($chatcommand[1]) . '$>$i!';
					}
				}

				else // no login provided
				{
					$length=strlen($command[0])+2;
					$txt = substr($chat[1][2],$length);
					if(strlen($txt)>2)
					{
						$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' '.$txt;
					}
					else
					{
						$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1];
					}
				}
			}
			else
			{
				$length=strlen($command[0])+2;
				$txt = substr($chat[1][2],$length);
				if(strlen($txt)>2)
				{
					$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1].' '.$txt;
				}
				else
				{
					$msg = '$ff0[$<' . $player->nickname . '$>] $ff0$i'.$command[1];
				}
			}			
		}
		
		$this->maniaControl->getChat()->sendChat($msg, null, false);
	}
	 

	/**
	 * Load the settings into an array
	 */
	public function loadIntoArray()
	{
		$this->cmd = array();
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_0) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_0);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_1) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_1);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_2) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_2);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_3) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_3);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_4) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_4);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_5) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_5);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_6) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_6);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_7) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_7);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_8) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_8);
		}
		if ($this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_9) != '')
		{
			$this->cmd[]=$this->maniaControl->settingManager->getSetting($this, self::SETTING_CMD_TXT_9);
		}
	}


	/**
	 * Checks if a Player is in the PlayerList and returns the nickname if he is, can be called per login, pid or nickname or lj for
	 * (last joined)
	 *
	 * @param mixed $login
	 * @return mixed
	 */
	private function getTarget($login) {
		$player = null;
		foreach ($this->maniaControl->getPlayerManager()
		                            ->getPlayers() as $player) {
			if ($login == $player || $login == $player->login || $login == $player->pid || $login == $player->nickname) {
				return $player->nickname;
			}
		}

		if ($player && strtolower($login) === 'lj') {
			return $player->nickname;
		}

		//returns the text given if nothing matches
		return false;
	}
}
